define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var dcommon = require("$UI/system/lib/delit");
	var Data = require("$UI/system/components/justep/data/data");
	var serverUrl = "";	
	var menuId;
	var title;

	var Model = function(){
		this.callParent();
		serverUrl = dcommon.ServerUrl;
	};

	Model.prototype.modelParamsReceive = function(event){
		menuId=this.getContext().getRequestParameter("id");
		title=this.getContext().getRequestParameter("title");
		
		this.comp("x-titlebar").set("title", title);
		
		this.loadMainData();
	};
	//加载菜单
	Model.prototype.loadMainData = function() {
		var data=this.comp("data");
		data.clear();
		if (dcommon.SID == null || dcommon.SID == "")
			return;
		var self = this;
		debugger;
		$.ajax({
			url : serverUrl + "WebHandler.ashx?QNAME=MOBILE_BASE&CMD=8013",
			type : "post",
			async : false,
			cache : false,
			data : {
				"sid" : dcommon.SID,
				"menuid":menuId
			},// 键值 map传参数
			"success" : function(reData) {
				debugger;
				if (reData.length > 0) {
					data.loadData(reData, false);
					debugger;
				}
			},
			error : function() {
				throw justep.Error.create("加载数据失败");
			}
		});
	};
	
		// 图片路径转换
	Model.prototype.transUrl = function(row) {
		var url = (typeof row === "object") ? "../img/" + row.val("IMAGE_NAME") : row
		return require.toUrl(url);
	};
	
	Model.prototype.modelLoad = function(event){		
		
	};
	
	//隐藏
	Model.prototype.btnHideClick = function(event){
		debugger;
		var row = event.bindingContext.$object;
		row.val("DISABLED",1);
		row.val("EDIT_TIME", justep.Date.toString(new Date(), 'yyyy-MM-ddThh:mm:ss.fffZ')); 
	};
	
	//显示
	Model.prototype.btnShowClick = function(event){
		var row = event.bindingContext.$object;
		row.val("DISABLED",0);		
		row.val("EDIT_TIME", justep.Date.toString(new Date(), 'yyyy-MM-ddThh:mm:ss.fffZ')); 
	};
	
	//上移
	Model.prototype.btnUpClick = function(event){
		debugger;
		//当前航
		var row = event.bindingContext.$object;
		var index=this.comp('data').getRowIndex(row);
		if(index==0){
		justep.Util.hint("不能上移第一行！", {type: 'danger', parent: this.getRootNode()});
			return;
		}
		//上一行
		var rowPre=this.comp('data').datas.get()[index-1]; 
		
		this.comp('data').exchangeRow(row, rowPre);
		row.val("EDIT_TIME", justep.Date.toString(new Date(), 'yyyy-MM-ddThh:mm:ss.fffZ')); 
		rowPre.val("EDIT_TIME", justep.Date.toString(new Date(), 'yyyy-MM-ddThh:mm:ss.fffZ'));
	};
	
	//下移
	Model.prototype.btnDownClick = function(event){		
		//当前航
		var row = event.bindingContext.$object;
		var index=this.comp('data').getRowIndex(row);
		if(index+1==this.comp('data').count()){
		justep.Util.hint("不能下移最后一行！", {type: 'danger', parent: this.getRootNode()});
			return;
		}
		//下一行
		var rowNext=this.comp('data').datas.get()[index+1];		
		this.comp('data').exchangeRow(row, rowNext);
		row.val("EDIT_TIME", justep.Date.toString(new Date(), 'yyyy-MM-ddThh:mm:ss.fffZ')); 
		rowNext.val("EDIT_TIME", justep.Date.toString(new Date(), 'yyyy-MM-ddThh:mm:ss.fffZ'));
	};
	
	
	Model.prototype.btnCanelClick = function(event){
		this.close();
	};
	
	//保存
	Model.prototype.btnSaveClick = function(event){
		//改变状态
		var datasoure=this.comp('data');
		datasoure.each(function(param){
				debugger;
                datasoure.setRowState(param.row,Data.STATE.NEW);
			});
		debugger;
		var self=this;
		var data = this.comp('data').toJson();
		var datastr = JSON.stringify(data);// json数组数据
		debugger;
		$.ajax({
			url : serverUrl + "WebHandler.ashx?QNAME=MOBILE_BASE&CMD=8014",
			type : "post",
			async : false,
			cache : false,
			data : {
				"sid" : dcommon.SID,
				"datastr":datastr
			},
			"success" : function(reData) {
				debugger;
				if (reData==true) {
					self.close();
				}
			},
			error : function() {
				throw justep.Error.create("加载数据失败");
			}
		});
	};
	
	//打开菜单
	Model.prototype.btnOpenMenuClick = function(event){
		var row = event.bindingContext.$object;
		justep.Shell.showPage(require.toUrl('./userMenuManager.w?id='+row.val("MOBILE_ID")+'&title='+row.val("TITLE")));
	};
	
	
	return Model;
});