define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var dcommon = require("$UI/system/lib/delit");

	var serverUrl = "";
	var userId = -1;// 用户ID
	var toOrCopy = "";// 选择收件人，还是抄送人打开的组织机构选择
	var Ids = "";// 收件人ID串
	var personNames = ""// 发件人或者收件人名称串
	var data;
	var parent; // 父节点的row
	var append; // 数据是否增量加载
	var parentID; // 父ID
	var searchVal;// 条件查询的条件
	// var ids[];
	// var names[];
	var selectedItems = new Array();

	var Model = function() {
		this.callParent();
		$.support.cors = true;
		serverUrl = window.localStorage["serverUrl"];
		userId = window.localStorage["userId"];
	};

	// 接收参数
	Model.prototype.modelParamsReceive = function(event) {
		debugger;
		Ids = "";
		personNames = "";
		toOrCopy = "";
		selectedItems = new Array();
		searchVal="";
		// 回复邮件参数
		if (event.params.ReMailParam) {
			var reMailParam = event.params.ReMailParam;
			personNames = reMailParam.ToOrCopyNames;
			toOrCopy = reMailParam.ToOrCopy;
			Ids = reMailParam.IDS;
		}
		if (toOrCopy == "to") {
			this.comp("title").set({
				"title" : "选择收件人"
			});
		} else if (toOrCopy == "copy") {
			this.comp("title").set({
				"title" : "选择抄送人"
			});
		}
		if(Ids!="")
		{
			selectedItems.push({
				userId : Ids,
				userName : personNames
			});
		}
		this.comp("output_selectd").set({
			"value" : personNames
		});
		if (this.comp("output_selectd").value == "") {
			$("[xid=button_selectd_colse]").hide();
		} else {
			$("[xid=button_selectd_colse]").show();
			;
		}
		this.comp("dataOrg").clear();
		this.comp("tree1").refresh(true);
	};
	// 刷新组织机构
	Model.prototype.dataOrgCustomRefresh = function(event) {
		 debugger;
		data = event.source;
		parent = event.options && event.options.parent; // 父节点的row
		append = event.options && event.options.append; // 数据是否增量加载
		parentID = parent ? parent.getID() : "1000"; // 父ID
		$.ajax({
			url : serverUrl + "WebHandler.ashx?QNAME=MOBILE_BASE&CMD=1007",
			type : "post",
			dateType : "json",
			async : false,
			cache : false,
			data : {
				"upperId" : parentID,
				"SID" : dcommon.SID,
				"SEARCHVAL" : searchVal
			},
			"success" : function(reData) {
				debugger;
				if (reData.length > 0) {
					// 加载完成后判断是否选择过人员，如果选择过就需要勾选已选择的人员
					var ids;
					if (toOrCopy == "to") {
						if (Ids != "") {
							ids = Ids.split(";");
						}
					} else if (toOrCopy == "copy") {
						if (Ids != "") {
							ids = Ids.split(";");
						}
					}
					if (ids != null) {
						for (var i = 0; i < reData.length; i++) {
							for (var j = 0; j < ids.length; j++) {
								if (reData[i]["ID"] == ids[j]) {
									reData[i]["CHECKD"] = "true";
								}
							}
						}
					}
					data.loadData(reData, append, parent);
				} else {
					justep.Util.hint("该下级没有人员", {
						"type" : "info",
						"position" : "bottom",
						"style" : "text-align:center;"
					})
				}
			},
			error : function() {
				throw justep.Error.create("加载数据失败");
			}
		});
	};

	// 组织机构行选择,显示下级
	var allowSubData = false;// 是否允许加载子数据，如果是自己写的行点击事件就加载，否则在tree加载子数据前取消
	Model.prototype.treeRowClick = function(event) {
		debugger;
		var parentRow = event.bindingContext.$object; // 父级行
		// 如果当前行不是人员就执行显示下级操作
		if (parentRow.val("TYPE") != 5) {
			event.source = this.comp("dataOrg");
			event.options = {
				parent : parentRow,
				append : true
			};
			// 判断下级是否加载过了，加载了就不读取数据了，重新打开该界面时再重新加载
			var cilcount = event.source.find([ "UPPER_ID" ], [ parentRow.val("ID") ], true, false, false, true);// 查找下级是否有数据，有就不从服务器获取
			if (cilcount.length == 0) {
				Model.prototype.dataOrgCustomRefresh(event);
			} else {
				event.source.loadData(null, false, parentRow);
			}
			allowSubData = true;
		}
	};

	// 树型部件加载子数据前事件
	Model.prototype.tree1BeforeLoadChildren = function(event) {
		debugger;
		// 判断不允许加载子数据就取消加载子数据操作，这样点击勾选框就正常了。
		if (allowSubData == false) {
			event.cancel = true;
		}
		allowSubData = false;
	};

	// 清除已经选择的内容
	Model.prototype.button_selectd_colseClick = function(event) {
		debugger;
		this.clearChoosed();
	};
	Model.prototype.clearChoosed = function() {
		var self = this;
//		if (toOrCopy == "to") {
//			personNames = "";
//			Ids = "";
//		} else if (toOrCopy == "copy") {
//			personNames = "";
//			Ids = "";
//		}
		self.comp("output_selectd").set({
			"value" : ""
		});
//		var rowList = self.comp("dataOrg").find([ "CHECKD" ], [ "true" ], false, false, false, true);
//		for (var i = 0; i < rowList.length; i++) {
//			rowList[i].row["CHECKD"] = "false";
//		}
//		// 去掉所有复选框的勾选，因为上面更改数据，界面没有想用取消勾选，所有下面循环处理界面取消勾选。
		var checdBoxs = document.getElementsByName("usercheck");
		for (var i = 0; i < checdBoxs.length; i++) {
			if (checdBoxs[i].type == "checkbox") {
				checdBoxs[i].checked = false;
			}
		}
		selectedItems = new Array();
		$("[xid=button_selectd_colse]").hide();
	}
	// 勾选框值变化，设置以选择内容
	Model.prototype.checkbox_userChange = function(event) {
		debugger;
		var selectd = "";
		var nowName = event.bindingContext.$object.val("NAME");
		var userId = event.bindingContext.$object.val("REAL_ID");
		if (event.checked) {
			selectedItems.push({
				userId : userId,
				userName : nowName
			});
		} else {
			for (i = 0; i < selectedItems.length; i++) {
				if (selectedItems[i].userId == userId) {
					selectedItems.splice(i, 1);
					break;
				}
			}
		}
		
		for (i = 0; i < selectedItems.length; i++) {
			selectd += selectedItems[i].userName + ";";
		}
        if(selectd.slice(0, 5)=="null;"){
        	selectd=selectd.replace("null;", "");
        }
		this.comp("output_selectd").set({
			"value" : selectd
		});
		if (selectd == "") {
			$("[xid=button_selectd_colse]").hide();
		} else {
			$("[xid=button_selectd_colse]").show();
		}
	};

	// 确定已选人员
	Model.prototype.button_sendClick = function(event) {
		debugger;
		// 查找所有选中的行
		Ids="";
		// 选择人员确定功能
		if (toOrCopy == "to") {
			debugger;
			personNames = "";
			toOrCopy = "to";
			// Ids="";
			for (var i = 0; i < selectedItems.length; i++) {
				personNames +=  selectedItems[i].userName + ";";
				Ids +=  selectedItems[i].userId + ";";
			}
		} else if (toOrCopy == "copy") {
			personNames = "";
			toOrCopy = "copy";
			// Ids="";
			for (var i = 0; i < selectedItems.length; i++) {
				personNames += selectedItems[i].userName + ";";
				Ids += selectedItems[i].userId + ";";
			}
		}
        
		// 回传参数
		debugger;
		personNames = this.comp("output_selectd").get("value");
		var orgReParam = {
			"PersonNames" : personNames,
			"IDS" : Ids,
			"ToOrCopy" : toOrCopy
		};
		this.owner.send({
			"OrgReParam" : orgReParam
		});
		this.close();
	};

	// 搜索
	Model.prototype.button_SearchClick = function(event) {
		debugger;
		searchVal = this.comp("searchInput").get("value");
		 this.comp("tree1").refresh(true);
	};
	return Model;
});