define(function(require) {
	var $ = require('jquery');
	var dcommon = require("$UI/system/lib/delit");
	var menu = require("./MENU");
	require("cordova!cordova-plugin-device");
	var JPushInstance = function() {
		if (window.plugins && window.plugins.jPushPlugin) {
			document.addEventListener("deviceready", this.onDeviceReady.bind(this), false);
			document.addEventListener("jpush.openNotification", this.onOpenNotification.bind(this), false);
			document.addEventListener("jpush.receiveNotification", this.onReceiveNotification.bind(this), false);
			document.addEventListener("jpush.receiveMessage", this.onReceiveMessage.bind(this), false);
		}
	};
	
	//hcr 解决第一次获取失败的问题
	JPushInstance.prototype.getRegistrationID = function(){
		 var dtd = $.Deferred();
		 if (this.registrationID){
			 dtd.resolve(this.registrationID);
		 }else{
			 if (window.plugins && window.plugins.jPushPlugin){
				 window.plugins.jPushPlugin.getRegistrationID(function(registrationID) {
					 self.registrationID = registrationID;
					 if (self.registrationID){
						 dtd.resolve(self.registrationID);	 
					 }else{
						 dtd.reject();
					 }
				 });
			 }else{
				 dtd.reject();
			 }
		 }
		 return dtd.promise();
	};
	

	JPushInstance.prototype.onDeviceReady = function() {
		var self = this;
		window.plugins.jPushPlugin.init();
		window.plugins.jPushPlugin.getRegistrationID(function(registrationID) {
			self.registrationID = registrationID;
		});
		if (device.platform == "Android") {
			window.plugins.jPushPlugin.setDebugMode(false);
			window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
		} else {
			window.plugins.jPushPlugin.setDebugMode(false);
			window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
		}
	};

	JPushInstance.prototype.onOpenNotification = function(event) {
		var alertContent;
		var type;
		if (device.platform == "Android") {
			alertContent = window.plugins.jPushPlugin.openNotification.alert;
			type=window.plugins.jPushPlugin.openNotification.extras.TYPE;
		} else {
			alertContent = event.aps.alert;
			type=event.TYPE;
		}
		window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
		
		//登录后才能切换，否则切换到登录界面。
		if (dcommon.SID == null || dcommon.SID == "")
		{
			justep.Util.hint("请先登录系统。");
			return;
		}
		if(type=="MAIL")
		{
			justep.Shell.showPage("mail");
		}
		else if(type=="NOTICE")
		{
			justep.Shell.showPage("notice");
		}
		else if(type=="FLOW")
		{
			justep.Shell.showPage("flow");
		}
		else
		{			
			//type为菜单ID的时候，打开对应的菜单。
			$.ajax({
				url : dcommon.ServerUrl + "WebHandler.ashx?QNAME=MOBILE_BASE&CMD=1504",
				type : "post",
				async : false,
				cache : false,
				data : {
					"sid" : dcommon.SID,
					"ID":type
				},
				"success" : function(reData) {
					debugger;
					if (reData) {
						var data=reData;
						menu.openPage(data.PAGE_NAME,data.ID,data.TITLE,data.PARAMS,data.PARAMS1);
						//data.loadData(reData, false);						
					}
				},
				error : function() {
					throw justep.Error.create("加载数据失败");
				}
			});
		}
	};

	JPushInstance.prototype.onReceiveNotification = function(event) {
		var alertContent;
        if(device.platform == "Android"){
        	alertContent = window.plugins.jPushPlugin.receiveNotification.alert;
        }else{
        	alertContent   = event.aps.alert;
        }
        window.plugins.jPushPlugin.setApplicationIconBadgeNumber(1);
		//justep.Util.hint(alertContent);
	};

	JPushInstance.prototype.onReceiveMessage = function() {
		var message;
        if(device.platform == "Android"){
       		 message = window.plugins.jPushPlugin.receiveMessage.message;
        }else{
              message   = event.content;
        }
        window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
		justep.Util.hint(message);
	};

	return new JPushInstance();
});