define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var dcommon = require("$UI/system/lib/delit");
	var Data = require("$UI/system/components/justep/data/data");
	var LabelEdit = require("$UI/system/components/justep/labelEdit/labelEdit");
	var Input = require("$UI/system/components/justep/input/input");
	var Output = require("$UI/system/components/justep/output/output");
	var TextArea = require("$UI/system/components/justep/textarea/textarea");
	var RadioGroup = require("$UI/system/components/justep/select/radioGroup");
	var Button = require("$UI/system/components/justep/button/button");
	
	require("cordova!cordova-open");
	require("cordova!cordova-plugin-file");
	require("cordova!cordova-plugin-file-transfer");
	
	var fileApi = require("$UI/system/components/justep/docCommon/fileApi");
	
	var localstorage="file:///storage/emulated/0/delit/";
	
	var serverUrl = "";
	var threadId = "";
	var flow;
	var fieldData;
	var myData;
	var taskType = "";// 值为3的时候是审批，需要显示审批窗体并提交意见。
	var opinion = "";// 审批意见{"result":0,"reasion":"审批意见text"}
	var nextNodeId = "";// 下一步节点的id;
	var toIds = "";// 下一步处理人员ID集
	var copyIds = "";// 抄送人员ID集
	var approveParam = "";// 审批页面的参数集
	var signHtml = "";
	var checkType = "";// 校验类型

	// 选项类数据的字典表
	var selectItemDatas = new Array();
	// 加载生成附件DIV的时候会自动触发单击事件，此变量用于判断是否处理完成附件DIV生成。
	var loading = false;

	var operFieldValue = "";// 审批字段原有的值
	var Model = function() {
		this.callParent();
		$.support.cors = true;
		$("[xid=btn_save]").hide();
		$("[xid=btn_approve]").hide();
	};

	Model.prototype.modelParamsReceive = function(event) {
		debugger;
		// 清空缓存
		nextNodeId = "";
		toIds = "";
		copyIds = "";
		// debugger;
		var self = this;
		fieldData = this.comp("fieldData");
		var context = this.getContext();
		serverUrl = dcommon.ServerUrl;
		threadId = context.getRequestParameter("id");
		var title = context.getRequestParameter("Title");
		$.ajax({

			// 加载流程状态
			url : serverUrl + "WebHandler.ashx?QNAME=MOBILE_BASE&CMD=1101",
			type : "post",
			async : false,
			cache : false,
			data : {
				"THREADID" : threadId,
				"SID" : dcommon.SID,
				"ISGW":"1",
			},
			"success" : function(reData) {
				// 如果查询的数据没有条数，就不用加载数据
				if (reData) {
					if (!reData.IsTableForm) {
						justep.Util.hint("不能处理非表单流程，请登录PC端处理 ！", {
							"type" : "warning",
							"position" : "top",
							"style" : "text-align:center;background-color:#F7DC97"
						});
						self.close();
						return;
					}
					flow = reData;
					taskType = flow.TaskType;
					var isCopy = flow.IsCopy;
					opinion = {
						"result" : flow.Result,
						"reasion" : flow.Reasion
					};
					if (isCopy === true) {
						$("[xid=buttonGroup1]").hide();
						$("[xid=buttonGroup2]").hide();
					}
					debugger;
					if (flow.IsBack) {
						justep.Util.hint("退回原因：<br>&nbsp;&nbsp;<font color=red>" + flow.BackReasion+"</font>", {
							"type" : "warning",
							"delay" : 100000,
							"position" : "top",
							"style" : "text-align:left;background-color:#F7DC97"
						});
					}
					if (taskType == 3) {// 审批
						$("[xid=btn_approve]").show();
					}
					if (taskType == 4) {// 签发
						self.comp("btn_oper").set({
							"label" : "签收"
						});
					}
					if(flow.State==0)
					{
						//流程已处理完成。暂时存、提交、中止按钮不显示
						$("[xid=bottom1]").hide();
						$("[xid=button_Back]").hide();
						$("[xid=button_Stop]").hide();
					}
				}
			},
			error : function() {
				throw justep.Error.create("加载流程数据失败");
			}
		});
		$("[xid=txt_resion]").val(opinion.reasion);
		if (flow) {
			 debugger;
			// 加载表结构
			$.ajax({
				url : serverUrl + "WebHandler.ashx?QNAME=MOBILE_BASE&CMD=1102",
				type : "post",
				async : false,
				cache : false,
				data : {
					"THREADID" : threadId,
					"SID" : dcommon.SID,
					"ISGW":"1",
				},
				"success" : function(reData1) {
					// 如果查询的数据没有条数，就不用加载数据
					if (reData1.rows.length > 0) {
						fieldData.loadData(reData1, false);
					}
				},
				error : function(e) {
					throw justep.Error.create("加载表结构数据失败" + e);
				}
			});
			var editflag = false;
			if (fieldData.getTotal() > 0) {
				self.createData(fieldData);// 创建data
				self.flowDataLoad();// 加载流程数据
				fieldData.each(function(param) {
					debugger;
					var fieldName = param.row.val("FIELD_NAME");
					var fieldAlias = param.row.val("FIELD_ALIAS");// 用于生成label文字
					var fieldType = param.row.val("FIELD_TYPE");// 字段类型
					var fieldEditType = param.row.val("FIELD_EDIT_TYPE");// 编辑方式
					var isShowMode = param.row.val("SHOW_MODE");// 流程节点显示方式设置：0为编辑，1为可见，2为不可见
					var displayStyle=param.row.val("DISPLAY_STYLE")
					if(flow.State==0 && isShowMode==0){isShowMode=1;}
					var isVisible = param.row.val("VISIBLE");// 是否可见，
					// 1为true，0为false
					var isReadOnly = param.row.val("READ_ONLY");// 是否只读，
					// 1为true，0为false
					var checkWarning = param.row.val("CHECK_WARNING");// 效验提示，
					// 校验为true时的提示。
					// 提示内容
					checkType = param.row.val("FIELD_CHECK_TYPE")// 效验方式，
					// 对应FWFramework.TableReader.FieldCheckType类型，0为无效验，1为非空，2为唯一
					if (isShowMode == 0) {
						editflag = true;
						if (isVisible == 1 && fieldEditType == 7)
							self.createItemData(fieldName, fieldType, fieldEditType, isShowMode);
					}
					// 获取选择数据，并创建对应的数据库

					self.createControl(fieldName, fieldAlias, fieldType, fieldEditType, isShowMode, isVisible, isReadOnly, checkWarning, checkType,displayStyle);// 创建组件
				});
				if (editflag)
					$("[xid=btn_save]").show();
			}
		}
	};

	var itemCount = 0;
	Model.prototype.createItemData = function(fieldName, fieldType, fieldEditType, isShowMode) {
		 debugger;
		var dataType = "String";// [ "String", "Integer", "Double"];
		if (fieldType == 1)
			dataType = "Integer";
		else if (fieldType == 2)
			dataType = "Double";
		var itemData = new Data(this, {
			xid : "Item_" + fieldName,
			defCols : {
				VALUE : {
					type : dataType,
					label : 'VALUE'
				},
				DISPLAY : {
					type : 'String',
					label : 'DISPLAY'
				},
			},
			idColumn : 'VALUE'
		});
		selectItemDatas[itemCount] = itemData;
		// 获取数据选择的数据
		$.ajax({
			url : serverUrl + "WebHandler.ashx?QNAME=MOBILE_BASE&CMD=1017",
			type : "post",
			async : false,
			cache : false,
			data : {
				"THREADID" : threadId,
				"SID" : dcommon.SID,
				"FLOWID" : flow.FlowId,
				"FIELD_NAME" : fieldName
			},
			"success" : function(reData1) {
				// debugger;
				if (reData1.rows.length > 0) {
					itemData.loadData(reData1, false);
					itemData.first();
				}
			},
			error : function() {
				throw justep.Error.create("加载选项表失败" + fieldName);
			}
		});
	};

	// 动态创建表myData;
	Model.prototype.createData = function(data) {
		var idCol;
		var dataType = [ "String", "Integer", "Double", "DateTime", "String", "String", "String" ];
		data.each(function(param) {
			if (param.row.val("FIELD_PRIMARYKEY") == 1) {
				idCol = param.row.val("FIELD_NAME");
				return;
			}
		});
		var defCol = "";
		data.each(function(param) {
			var fieldName = param.row.val("FIELD_NAME");// 字段
			var fieldAlias = param.row.val("FIELD_ALIAS");// label
			var fieldType = param.row.val("FIELD_TYPE");// 字段类型

			defCol += '"' + fieldName + '":{"type":"' + dataType[fieldType] + '","label":"' + fieldAlias + '"},'
		});
		var reg = /,$/gi;
		defCol = "{" + defCol.replace(reg, "") + "}";
		var result = JSON.parse(defCol);
		myData = new Data(this, {
			xid : "myTable",
			defCols : result,
			idColumn : idCol
		});
		debugger;
	};
	// 加载流程数据
	Model.prototype.flowDataLoad = function() {
		var context = this.getContext();
		var threadId = context.getRequestParameter("id");
		$.ajax({
			url : serverUrl + "WebHandler.ashx?QNAME=MOBILE_BASE&CMD=1103",
			type : "post",
			async : false,
			cache : false,
			data : {
				"THREADID" : threadId,
				"SID" : dcommon.SID
			},
			"success" : function(reData1) {
				if (reData1.rows.length > 0) {
					myData.loadData(reData1, false);
					myData.first();
					if (flow.OperSetting!=null && flow.OperSetting.AddResionToField == true && flow.OperSetting.FieldName != "") {
						operFieldValue = myData.getValue(flow.OperSetting.FieldName);
					}
				}
			},
			error : function() {
				throw justep.Error.create("加载流程数据失败");
			}
		});
	}
	// 加载附件信息
	var fileData = "";
	Model.prototype.refreshAttach = function(attcode) {
		fileData = "";
		debugger;
		var self = this;
		fileData = self.comp("fileData");
		fileData.clear();
		$.ajax({
			url : serverUrl + "WebHandler.ashx?QNAME=MOBILE_BASE&CMD=1301",
			type : "post",
			async : false,
			cache : false,
			data : {
				"attcode" : attcode,
				"SID" : dcommon.SID
			},
			"success" : function(reData1) {
				debugger;
				// 如果查询的数据没有条数，就不用加载数据
				if (reData1.rows.length > 0) {
					fileData.loadData(reData1, false);
				} else if (reData1 == "") {
					throw justep.Error.create("暂无附件信息！");
					return;
				} else {
					self.getElementByXid("body2").style.display = "none";
				}
			},
			error : function() {
				throw justep.Error.create("加载数据失败2");
			}
		});
	};

	Model.prototype.AddAtt = function(childNode) {
		loading = true;
		fileData.each(function(param) {
			debugger;
			var si = "";
			var size = param.row.val('FILE_SIZE');
			if (size < 100) {
				si = (size) + "Byte";
			} else if (size < 105000) {
				si = (size / 1024).toFixed(2) + "K";
			} else if (size < 107000000) {
				si = (size / 1024 / 1024).toFixed(2) + "M";
			}
			var div_Attch = $("<div data-bind='click:windowOpen(\"" + param.row.val('ID') + "\")' style='width:80%;text-align:left;padding-left:7px;'><a>" + param.row.val('FILE_NAME') + "(" + si
					+ ")" + "</a></div>");
			justep.Bind.addNodes(childNode, div_Attch);
		});
		loading = false;
	};

	// 动态创建组件
	Model.prototype.createControl = function(fieldName, fieldAlias, fieldType, fieldEditType, isShowMode, isVisible, isReadOnly, checkWarning, CheckType,displayStyle) {
		debugger;
		var self = this;
		if (isShowMode == 2 || isVisible == 0) {
			return;
		}
		var parentNode = this.getElementByXid("body2");// 父组件 panel中的body
		var option = {
			parentNode : parentNode,
			xid : fieldName,
			class : 'x-label-edit x-label20',
			'style' : 'width:100%;text-align:left;border-bottom-style:solid;border-bottom-width:thin;border-bottom-color:#eeeeee;'
		};
		new LabelEdit(option);

		var childNode = this.getElementByXid(fieldName);
		var div;
		if (CheckType == 1) {
			div = $("<label style='width:20%;text-align:right;vertical-align:top;'>" + fieldAlias + "<font color='red'>*</font>:</label>");// 动态创建label
		}
		div = $("<label style='width:20%;text-align:right;vertical-align:top;'>" + fieldAlias + "：</label>");// 动态创建label

		justep.Bind.addNodes(childNode, div);
		// 根据条件动态创建input
		// fieldType 字段类型 ; fieldEditType 编辑框展示类型
		// 当fieldType=0 ||fieldType=5是 字符串类型
		// fieldType=5 文章类型 fieldType=4备注类型

		// if((fieldType==0||fieldType==5)&&fieldEditType==7 ){//平面展示
		// var dt=this.comp("dicRecord")
		// debugger;
		// var option1 = {
		// 'bind-ref' :"dicRecord.ref('ITEM_DISPLAYNAME')",
		// 'bind-labelRef':"dicRecord.ref('ITEM_DISPLAYNAME')"
		// };
		// new Select(option1);
		// }
		// 创建select
		// if (fieldType == 0 && fieldEditType == 7 && isShowMode == 0) {// 平面展示
		// // 在当前页面的parent节点下创建html select组件
		// //动态创建select
		// var mySelect = document.createElement("select");
		// mySelect.id = fieldName;
		// childNode.appendChild(mySelect);
		// //添加选项option，根据id查找对象
		// var obj=document.getElementById(fieldName);
		// //添加一个选项
		// obj.add(new Option(fieldName,fieldName));
		// var index=obj.selectedIndex; //序号，取当前选中选项的序号
		// var val = obj.options[index].value;
		// }
		var attcode = "";
		if (fieldType == 0 && fieldEditType == 29 && isShowMode == 1) {// 附件,只读
			debugger;

			var div_childNode1 = $("<div id='div_childNode' style='width:80%;text-align:left;padding-left:7px;'></div>");
			justep.Bind.addNodes(childNode, div_childNode1);
			var div_childNode2 = document.getElementById("div_childNode");

			var fieldName_val = myData.getValue(fieldName);
			var div_Attch = "";
			if (fieldName_val !== "" && fieldName_val !== undefined) {
				attcode = fieldName_val.split('|')[0];
				if (attcode !== "") {
					self.refreshAttach(attcode);
					if (fileData.length < 0 || fileData == "")
						return;
					self.AddAtt(div_childNode2);
					debugger;
				}
			} else {
				div_Attch = $("<div style='width:80%;text-align:left;padding-left:7px;'><a></a></div>");
				justep.Bind.addNodes(div_childNode2, div_Attch);
			}
			return;
		}
		// 附件类型
		if (fieldType == 0 && fieldEditType == 29 && isShowMode == 0) {// 附件，可上传
			debugger;
			var div_childNode1 = $("<div id='div_childNode' style='width:80%;text-align:left;padding-left:7px;'></div>");
			justep.Bind.addNodes(childNode, div_childNode1);
			var div_childNode2 = document.getElementById("div_childNode");

			var fieldName_val = myData.getValue(fieldName);
			var div_Attch = "";
			if (fieldName_val !== "" && fieldName_val !== undefined) {
				attcode = fieldName_val.split('|')[0];
				if (attcode !== "") {
					self.refreshAttach(attcode);
					if (fileData.length < 0 || fileData == "")
						return;
					self.AddAtt(div_childNode2);
				}
			} else {
				div_Attch = $("<div style='width:80%;text-align:left;padding-left:7px;'><a></a></div>");
				justep.Bind.addNodes(div_childNode2, div_Attch);
			}
			var flag_Attch = {
				"xid" : "btn1",
				"label" : "选择",
				"parentNode" : childNode,
				"class" : "btn btn btn-default",
				'style' : 'width:auto;text-align:left;padding-left:7px;padding-bottom:12px'
			};
			var button = new Button(flag_Attch);
			var dataParam = {
				"AttCode" : attcode,
				"FieldName" : fieldName
			};
			button.on("onClick", function(event) {
				debugger;
				var url = require.toUrl('../common/upLoad.w');
				var dialog = self.comp("windowDialog");
				dialog.open({
					src : url,
					params : dataParam
				});
			});
			return;
		}
		// 签名类型
		if (fieldType == 0 && fieldEditType == 5) {// 签名
			if (isShowMode != 2) {
				debugger;
				var displayfieldName = fieldName + "$VIEW";
				var fieldName_val = myData.getValue(displayfieldName);
				var newDiv = "";
				if (fieldName_val != null && fieldName_val.length > 0) {
					newDiv = $("<div style='width:80%;text-align:left;padding-left:7px;'><img id=" + fieldName + "_img width=128 height=60  src=\"" + fieldName_val + "\"></div>");
				} else {
					newDiv = $("<div style='width:80%;text-align:left;padding-left:7px;'></div>");// 动态创建div
				}
				
				justep.Bind.addNodes(childNode, newDiv);

				if (isShowMode == 0) {
					var flag = {
						"xid" : "btn1",
						"label" : "选择",
						"parentNode" : childNode,
						"class" : "btn btn btn-default",
						'style' : 'width:auto;text-align:left;padding-left:7px;padding-bottom:12px'
					};
					var button = new Button(flag);
					button.on("onClick", function(event) {
						var url = require.toUrl('../flow/chooseSignature.w');
						var dialog = self.comp("windowDialog");
						dialog.open({
							src : url,
							params : {
								"ThreadID" : threadId,
								"FieldName" : fieldName
							}
						});
					});
				}
				return;
			}
		}

		// 单选类型
		if (fieldType == 0 && fieldEditType == 7 && isShowMode == 0) {// 平面展示
			// 在当前页面的parent节点下创建RadioGroup组件
			var wing = {
				"xid" : fieldName,
				"bind-ref" : "myTable.ref('" + fieldName + "')",
				"bind-itemset" : "Item_" + fieldName + ".datas",
				"bind-itemsetValue" : "ref('VALUE')",
				"bind-itemsetLabel" : "ref('DISPLAY')",
				"parentNode" : childNode,
				'style' : 'width:80%;text-align:left;padding-left:7px;padding-bottom:12px'
			};
			new RadioGroup(wing);
			return;
		}
		// 只读或只显示值
		if (isReadOnly == 1 || isShowMode == 1) {
			//特殊处理word类型。
			if(fieldEditType==30)
			{
				var flag = {
						"xid" :fieldName ,
						"label" : "点此打开文档>>",
						"parentNode" : childNode,
						"class" : "btn btn-default btn-block",
						"icon=":"icon-android-note",
						"style" : "width:80%;text-align:center;padding-left:7px;padding-bottom:12px"
					};
					var button = new Button(flag);
					button.on("onClick", function(event) {
						Model.prototype.downWord();
					});
			}
			else
			{
				var option1 = {
					parentNode : childNode,
					xid : fieldName, // ,
					'bind-ref' : "myTable.ref('" + fieldName + "')",
					'style' : 'width:80%;text-align:left;padding-left:7px;padding-bottom:12px'
				};
				new Output(option1);
			}
			return;
		}
		// html类型
		else if ((fieldType == 4 || fieldType == 5) && fieldEditType == 28 && isShowMode == 0) {
			debugger;
			// displayfieldName = fieldName + "_DISPLAYNAME_VIEW";
			var fieldName_val = myData.getValue(fieldName);
			var newDiv = $("<div contentEditable='true' style='width:80%;border:1px solid #EEEEEE;text-align:left;padding-left:7px;'>" + fieldName_val + "</div>");// 动态创建div
			justep.Bind.addNodes(childNode, newDiv);
			return;
		}
		// 字符类型
		else if ((fieldType == 0 ) && fieldEditType == 0 && isShowMode == 0 && displayStyle==2) {
			var option7 = {
				parentNode : childNode,
				xid : fieldName, // ,
				'bind-ref' : "myTable.ref('" + fieldName + "')",
				'style' : 'width:80%;height:120px;text-align:left;padding-left:7px;padding-bottom:12px'
			};
			new TextArea(option7);
			return;
		}
		// Integer类型
		else if ((fieldType == 1 || fieldType == 2) && fieldEditType == 0 && isShowMode == 0) {
			var option2 = {
				parentNode : childNode,
				xid : fieldName,
				placeHolder : '请输入内容',
				formatter : '0,000',
				dataType : 'Integer', // ,
				'bind-ref' : "myTable.ref('" + fieldName + "')",
				'style' : 'width:80%;text-align:left;padding-left:7px;padding-bottom:12px'
			};
			new Input(option2);
			return;
		}
		// date
		else if (fieldType == 3 && fieldEditType == 18 && isShowMode == 0) {
			// 类型
			var option_Date = {
				parentNode : childNode,
				xid : fieldName,
				dataType : 'Date',
				// formatter : 'yyyy-MM-dd',
				'bind-ref' : "myTable.ref('" + fieldName + "')",
				'style' : 'width:80%;text-align:left;padding-left:7px;padding-bottom:12px'
			};
			new Input(option_Date);
			return;
		}
		// DateTime
		else if (fieldType == 3 && fieldEditType == 19 && isShowMode == 0) {

			var option_DT = {
				parentNode : childNode,
				xid : fieldName,
				dataType : 'DateTime',
				formatter : 'yyyy-MM-dd',
				'bind-ref' : "myTable.ref('" + fieldName + "')",
				'style' : 'width:80%;text-align:left;padding-left:7px;padding-bottom:12px'
			};
			new Input(option_DT);
			return;
		} // Time类型
		else if (fieldType == 3 && fieldEditType == 20 && isShowMode == 0) {
			var option_time = {
				parentNode : childNode,
				xid : fieldName,
				dataType : 'Time',
				// formatter : 'yyyy-MM-dd',
				'bind-ref' : "myTable.ref('" + fieldName + "')",
				'style' : 'width:80%;text-align:left;padding-left:7px;padding-bottom:12px'
			};
			new Input(option_time);
			return;
		}
		// 字符类型
		else if (fieldType == 0 && isShowMode == 0 && (fieldEditType != 7) && (fieldEditType != 5)) {
			var option4 = {
				parentNode : childNode,
				xid : fieldName,
				'bind-ref' : "myTable.ref('" + fieldName + "')",
				'style' : 'width:80%;text-align:left;padding-left:7px;padding-bottom:12px'
			};
			new Input(option4);
			return;
		} else {
			var option5 = {
				parentNode : childNode,
				xid : fieldName,
				'bind-ref' : "myTable.ref('" + fieldName + "')",
				'style' : 'width:80%;text-align:left;padding-left:7px;padding-bottom:12px'
			};
			new Input(option5);
			return;
		}
	};
	
	Model.prototype.downWord=function()
	{
		var a=myData.getValue("文档ID");
		//alert(a);
		
		var filePath =localstorage + a+".doc"; // 下载路径,数据库保存文件名
		var uri = serverUrl + "DownloadFile.ashx?sid=" + dcommon.SID + "&comfrom=word&file_id="+a; // 下载地址
		
		//alert(uri);
		
		fileApi.browse(uri,  a+".doc").done(function(){
		}).fail(function(){
		    alert("打开出错");
		});;
		
		return;
		
		var fileTransfer = new FileTransfer();

		fileTransfer.download( // 调用对象的下载方法，开始下载
		uri, filePath, function(entry) {
			justep.Util.hint("下载完成: " + entry.fullPath);
			// 这里下载完成后，将进度条隐藏或者写其他需要的代码
//			navigator.notification.progressStop();
			 //$("[xid=divProgress]").hide();
			// $("[xid=buttonOpen]").show();
			Model.prototype.openWord(filePath);
		}, function(error) { // 出错回调函数
			console.log("download error source " + error.source);
			console.log("download error target " + error.target);
			console.log("upload error code" + error.code);
		}, false, {
			headers : {
				"Authorization" : "Basic dGVzdHVzZXJuYW1lOnRlc3RwYXNzd29yZA=="
			}
		});
	};
	
	Model.prototype.openWord=function(file)
	{
		var open = cordova.plugins.disusered.open;
		function success() {
			justep.Util.hint('正在打开！');
		}
		function error(code) {
			if (code === 1) {
				alert('文件未在本地保存，请点击下载！');
			} else {
				justep.Util.hint('未知错误，请联系管理员！');
			}
		}
		open(file, success, error);
	};
	
	
	// 下载附件
	var pageUrl = require.toUrl('../common/downLoad.w');
	Model.prototype.windowOpen = function(id) {
		if (loading)
			return;
		var downUrl = "";
		var fileInfo = "";
		var fileName = "";
		var si = "";
		debugger;
		var fileUrl = serverUrl + "DownloadFile.ashx?sid=" + dcommon.SID + "&comfrom=table&file_id=";
		var rows1 = fileData.find([ 'ID' ], [ id ], false, false, false, true);
		if (rows1.length == 0)
			return;
		var size = rows1[0].val('FILE_SIZE');
		if (size < 100) {
			si = (size) + "Byte";
		} else if (size < 105000) {
			si = (size / 1024).toFixed(2) + "K";
		} else if (size < 107000000) {
			si = (size / 1024 / 1024).toFixed(2) + "M";
		}
		fileName = rows1[0].val("FILE_NAME");
		fileInfo = rows1[0].val('FILE_NAME') + "(" + si + ")";
		downUrl = fileUrl + id;
		var self = this;
		var dialog = self.comp("windowDialog");
		dialog.open({
			src : pageUrl,
			params : {
				"DownUrl" : downUrl,
				"FileInfo" : fileInfo,
				"FileName" : fileName
			}
		});
	};
	// 暂存数据
	Model.prototype.btn_saveClick = function(event) {
		debugger;
		var result = myData.toJson();
		var context = this.getContext();
		var threadId = context.getRequestParameter("id");
		var js = JSON.stringify(result);

		$.ajax({
			url : serverUrl + "WebHandler.ashx?QNAME=MOBILE_BASE&CMD=1015",
			type : "post",
			async : false,
			cache : false,
			data : {
				"THREADID" : threadId,
				"SID" : dcommon.SID,
				"table1" : js
			},
			"success" : function(reData) {
				// debugger;
				if (reData == "True") {
					justep.Util.hint("保存成功！");
				}
			}
		});
	};

	// 提交表单
	Model.prototype.btn_operClick = function(event) {
		fieldData.each(function(param) {
			// var checkWarning = param.row.val("CHECK_WARNING");// 效验提示，
			// 校验为true时的提示。
			// 提示内容
			checkType = param.row.val("FIELD_CHECK_TYPE");// 效验方式，
			// 对应FWFramework.TableReader.FieldCheckType类型，0为无效验，1为非空，2为唯一
			var fieldAlias = param.row.val("FIELD_ALIAS");// label
			if (checkType == 1) {
				myData.each(function(params) {
					var reVal = params.row.val(fieldAlias);
					if (reVal === "") {
						justep.Util.hint(fieldAlias + "不能为空！", {
							"type" : "warning",
							"position" : "middle",
							"style" : "text-align:center;"
						});
						return;
					}
				});
			}
		});
		this.goNextNode();
	};

	Model.prototype.goNextNode = function() {
		var self = this;
		var data = myData.toJson();
		var datastr = JSON.stringify(data);// json数组数据
		var reValue;
		var goNext = false;
		
		var reason =$("[xid=txt_resion]").val();
		// 如果是审批节点，需要先确定审批意见结论和意见是否填写。
		if (flow.TaskType == 3) {
			if (opinion.reasion === "") {
				this.openApprovePage();
				return;
			}
		}

		goNext = window.confirm("即将提交数据，进入下一步，是否继续？");
		if (!goNext)
			return;
		var signID = "";
		var isAgreeText = "";
		if (approveParam !== "") {
			reason = opinion.reason;
			signID = opinion.signId;
			isAgreeText = opinion.IsAgreeText;
		}
		var includeSign = "";
		var includeDate = "";
		var addReason = "";
		var fieldName = "";
		if (flow.OperSetting !== null) {
			includeSign = flow.OperSetting.IncludeSign;
			includeDate = flow.OperSetting.InculdeDate;
			addReason = flow.OperSetting.AddResionToField;
			fieldName = flow.OperSetting.FieldName;
		}
		debugger;
		$.ajax({
			url : serverUrl + "WebHandler.ashx?QNAME=MOBILE_BASE&CMD=1104",
			type : "post",
			async : false,
			cache : false,
			data : {
				"THREADID" : threadId,
				"SID" : dcommon.SID,
				"table1" : datastr,
				"nextNodeId" : nextNodeId,
				"ToIds" : toIds,
				"copyIds" : copyIds,
				"opinion" : reason,
				"signId" : signID,
				"isAgreeText" : isAgreeText,
				"includeSign" : includeSign,
				"includeDate" : includeDate,
				"addReason" : addReason,
				"fieldName" : fieldName,
				"signHTML" : signHtml
			},
			"success" : function(reData) {
				reValue = reData;
			}
		});
		debugger;
		var dialog = this.comp("windowDialog");// 弹窗组件
		if (reValue.TYPE == -99 || reValue.TYPE<0) {
			justep.Util.hint("Err:"+reValue.MSG, {
				"type" : "danger",
				"position" : "top",
				"style" : "text-align:center;"
			});
			// justep.Util.confirm(reValue.MSG, function() {
			// self.close();
			// }, null, "ok");
			return;
		}
		if (reValue.TYPE === 0 || reValue.TYPE === 1 || reValue.TYPE === 2 || reValue.TYPE === 3 || reValue.TYPE === 4) {
			justep.Util.confirm(reValue.MSG, function() {
				self.close();
			}, null, "ok");
			return;
		}
		if (reValue.TYPE === 101) {// 选择下一步操作步骤，即下一节点
			var dialog101 = this.comp("windowDialog101");// 弹窗组件101
			var url101_choose = require.toUrl('../flow/chooseNextNode.w');// 选择节点url101_choose
			dialog101.open({
				src : url101_choose,
				params : {
					nodeIds : reValue.Nodes
				}
			});
			return;
		} else if (reValue.TYPE === 102) {// 选择下一步操作人员
			// reValue.ALLOWMULIT;// ture 或者false reValue.NEEDCOPY;//ture
			// 或者false reValue.NODEALIAS; reValue.NODEDESC;
			debugger;
			var url102 = require.toUrl('../flow/nextDoPerson.w');// 选择人员url
			dialog.open({
				src : url102,
				params : {
					allowmulit : reValue.ALLOWMULIT,
					needCopy : reValue.NEEDCOPY,
					nodeAlias : reValue.NODEALIAS,
					desc : reValue.NODEDESC,
				}
			});
			return;
		} else if (reValue.TYPE === 103) {// 范围选人
			var url103 = require.toUrl('../flow/choosePerson.w');
			dialog.open({
				src : url103,
				params : {
					staffs : reValue.STAFFS
				}
			});
			return;
		}
	};

	// 审批意见
	Model.prototype.btn_approveClick = function(event) {
		// var context=this.getContext();
		// var threadId=context.getRequestParameter("id");
		this.openApprovePage();
	};
	Model.prototype.openApprovePage = function() {
		var dialog101 = this.comp("windowDialog101");// 弹窗组件101
		var url101 = require.toUrl('../flow/fillOpinion.w');// 审批意见url101
		dialog101.open({
			src : url101,
			params : {
				id : threadId,
				Opinion : opinion,
				Flow : flow
			}
		});
	};

	// 接收弹窗传过来的数据，提交表单流程 windowDialog
	Model.prototype.windowDialogReceive = function(event) {
		var signatureID;// 图片签名Id
		var fieldName;
		var password;
		if (event.data.toIds) {
			toIds = event.data.toIds;
			copyIds = event.data.copyIds;
			this.goNextNode();
			return;
		} else if (event.data.userid) {
			toIds = event.data.userid;
			this.goNextNode();
		} else if (event.data.SignatureParam) {
			signatureID = event.data.SignatureParam.SIGNID;
			fieldName = event.data.SignatureParam.FIELDNAME;
			password = event.data.SignatureParam.PASSWORD;
			// 获取签名调用密钥：
			// debugger;
			var key = "";
			$.ajax({
				url : serverUrl + "WebHandler.ashx?QNAME=MOBILE_BASE&CMD=1110",
				type : "post",
				async : false,
				cache : false,
				data : {
					"SID" : dcommon.SID,
					"signId" : signatureID,
					"password" : password,
				},
				"success" : function(reData) {
					key = reData;
				}
			});
			if (key == "") {
				justep.Util.hint("未能正常获取签名密钥。", {
					"type" : "warning",
					"position" : "middle",
					"style" : "text-align:center;"
				});
			} else if (key.substring(0, 3) == "Err") {
				justep.Util.hint(key, {
					"type" : "warning",
					"position" : "middle",
					"style" : "text-align:center;"
				});
			} else {
				// 设置图片显示
				var surl = serverUrl.replace("/Handler/", "/");
				var imgurl = surl + "getSignInfo.aspx?key=" + key;
				var imgId = fieldName + "_img";
				$("#" + imgId).attr('src', imgurl);
				// 设置数据
				myData.setValue(fieldName, key);
			}
		} else if (event.data.UploadParam) {
			var fieldName_Attch = event.data.UploadParam.FieldName;
			var fileName_Attch = event.data.UploadParam.FileName;
			var attcode_Attch = event.data.UploadParam.AttCode;
			var fieldName_AttchData = myData.getValue(fieldName_Attch);
			if (fieldName_AttchData === "" || fieldName_AttchData === undefined) {
				myData.setValue(fieldName_Attch, myData.getValue(fieldName_Attch) + attcode_Attch + "|" + fileName_Attch);
			} else {
				myData.setValue(fieldName_Attch, myData.getValue(fieldName_Attch) + "," + fileName_Attch);
			}
		}

	};
	// 时间格式
	Date.prototype.Format = function(fmt) { // author: meizz
		var o = {
			"M+" : this.getMonth() + 1, // 月份
			"d+" : this.getDate(), // 日
			"h+" : this.getHours(), // 小时
			"m+" : this.getMinutes(), // 分
			"s+" : this.getSeconds(), // 秒
			"q+" : Math.floor((this.getMonth() + 3) / 3), // 季度
			"S" : this.getMilliseconds()
		// 毫秒
		};
		if (/(y+)/.test(fmt))
			fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
		for ( var k in o)
			if (new RegExp("(" + k + ")").test(fmt))
				fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
		return fmt;
	};
	// 接收审批意见弹窗回传数据101
	Model.prototype.windowDialog101Receive = function(event) {
		var signID = "";
		debugger;
		if(event.data.goback)
		{
			this.close();
			return;
		}
		if (event.data.result >= 0) {
			opinion = event.data;

			approveParam = event.data;
			var includeSign = flow.OperSetting.IncludeSign;
			var includeDate = flow.OperSetting.InculdeDate;
			var addReason = flow.OperSetting.AddResionToField;
			var fieldName = flow.OperSetting.FieldName;
			var reason = approveParam.reason;
			signID = approveParam.signId;
			if (approveParam.IsChanged == "1") {
				return;
			}

			var isAgreeText = approveParam.IsAgreeText;
			if (addReason) {
				var time = (new Date()).Format("yyyy年MM月dd日");
				var signhtml = "<div>" + isAgreeText + "<br>" + reason + "</div>";
				if ((signID != null || signID != undefined || signID.length != 0) && includeSign) {
					var signUrl = serverUrl + "GetSign.ashx?id=" + signID;
					signhtml += "<div align=right><img width=128 height=60  src=" + signUrl + "></div>";
				}
				if(!includeSign)
				{
					signhtml+= "<div align=right style='FONT-FAMILY: 楷体_GB2312; FONT-SIZE: 18pt'>" + dcommon.UserInfo.UserName + "</div>";
				}
				if (includeDate) {
					signhtml += "<div align=right>" + time + "</div>";
				}
				signHtml = signhtml;

				myData.setValue(fieldName, operFieldValue + signHtml);
				signhtml = "";
				signhtml = "<div>" + isAgreeText + "<br>" + reason + "</div>";
				if ((signID != null || signID != undefined || signID.length != 0) && includeSign == true) {
					var signUrl1 = "[:serverUrl]Handler/GetSign.ashx?id=" + signID;
					signhtml += "<div align=right><img width=128 height=60  src=\"" + signUrl1 + "\"></div>";
				}
				if (includeDate)
					signhtml += "<div align=right>" + time + "</div>";
				signHtml = signhtml;
			}

			if (flow.OperSetting.OverGoNext == true) {
				this.goNextNode();
			}
		}
		if (event.data.nodeID) {
			nextNodeId = event.data.nodeID;
			this.goNextNode();
		}
	};
	// 退回
	Model.prototype.button_BackClick = function(event) {
		var dialog = this.comp("windowDialog101");// 弹窗组件101
		var url = require.toUrl('../flow/flowGoBack.w');// 审批意见url101
		dialog.open({
			src : url,
			params : {
				id : threadId,
				Flow : flow
			}
		});
	};
	// 流转历史
	Model.prototype.button_flowHistoryClick = function(event) {
		var context = this.getContext();
		var thread_Id = context.getRequestParameter("threadID");
		var url = require.toUrl('../flow/flowHistory.w?id=' + thread_Id);
		justep.Shell.showPage(url);
	};
	// 刷新
	Model.prototype.refreshBtnClick = function(event) {
		myData.refreshData();
	};
	// 终止流程
	Model.prototype.button_StopClick = function(event) {
		var self = this;
		var goBack = false;
		goBack = window.confirm("即将提交数据，中止该进程，是否继续？");
		if (!goBack) {
			return;
		}
		$.ajax({
			url : serverUrl + "WebHandler.ashx?QNAME=MOBILE_BASE&CMD=1203",
			type : "post",
			async : false,
			cache : false,
			data : {
				"THREADID" : threadId,
				"SID" : dcommon.SID
			},
			"success" : function(reData) {
				if (reData == "True") {
					justep.Util.hint("处理完成，流程已被中止！", {
						"type" : "info",
						"position" : "middle",
						"style" : "text-align:center;"
					});
					self.close();
				} else {
					justep.Util.hint("流程中止失败！", {
						"type" : "info",
						"position" : "middle",
						"style" : "text-align:center;"
					});
				}
			},
			error : function() {
				throw justep.Error.create("中止处理出错！");
			}
		});
	};
	// 查看流程图
	Model.prototype.button_flowImgClick = function(event) {

	};
	return Model;
});